//+------------------------------------------------------------------+
//|                                     MultiPositionExpert_v2.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"


#include <stdlib.mqh>

//---- input parameters
extern string     ExpertName = "MultiPositionExpert_v2";

extern string     Data = " Input Data ";
extern bool  DrawDayRange         = true;
extern color   CommentClr  = White;
bool       StopManageAcc    =   false; // Stop of Manage Account switch(Close All Trades)
extern int        Magic            =       45222; // Magic Number ( 0 - for All positions)
extern bool       UsePips          =    true;   
extern int        MA               =     12; 
extern double     ProfitTarget     =     3; // Profit target in pips or USD       	
extern double     MaxLoss          =     6; // Maximum total loss in pips or USD  
extern int        iSlippage        = 0;   

int totalPips=0;
double  totalProfits=0;
bool CloseSignal=false;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   DrawRange();
   ChartComment();
//----
   return(0);
  }

// ---- Scan Open Trades
int ScanOpenTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
    
   for(int cnt=0; cnt<=total-1; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
      if(OrderType()<=OP_SELL)
      {
      if(Magic > 0) if(OrderMagicNumber() == Magic) numords++;
      if(Magic == 0) numords++;
      }
   }   
   return(numords);
}

// Closing of Open Orders      
void OpenOrdClose()
{
    int total=OrdersTotal();
    for (int cnt=0;cnt<total;cnt++)
    { 
    OrderSelect(cnt, SELECT_BY_POS);   
    int mode=OrderType();
    bool res = false; 
    bool condition = false;
    if ( Magic>0 && OrderMagicNumber()==Magic ) condition = true;
    else if ( Magic==0 ) condition = true;
      if (condition && ( mode==OP_BUY || mode==OP_SELL ))
      { 
// - BUY Orders         
         if(mode==OP_BUY)
         {  
         res = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID), iSlippage,Yellow);
               
            if( !res )
            {
            Print(" BUY: OrderClose failed with error #",GetLastError());
            Print(" Ticket=",OrderTicket());
            Sleep(3000);
            }
         break;
         }
         else     
// - SELL Orders          
         if( mode == OP_SELL)
         {
         res = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK), iSlippage,White);
                 
            if( !res )
            {
            Print(" SELL: OrderClose failed with error #",GetLastError());
            Print(" Ticket=",OrderTicket());
            Sleep(3000);
            }
         break;    
         }  
      }                  
   }
}

void TotalProfit()
{
   int total=OrdersTotal();
   totalPips = 0;
   totalProfits = 0;
   for (int cnt=0;cnt<total;cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();
   bool condition = false;
   if ( Magic>0 && OrderMagicNumber()==Magic ) condition = true;
   else if ( Magic==0 ) condition = true;   
      if (condition)
      {      
         switch (mode)
         {
         case OP_BUY:
            totalPips += MathRound((MarketInfo(OrderSymbol(),MODE_BID)-OrderOpenPrice())/MarketInfo(OrderSymbol(),MODE_POINT));
            //totalPips += MathRound((Bid-OrderOpenPrice())/Point);
            totalProfits += OrderProfit();
            break;
            
         case OP_SELL:
            totalPips += MathRound((OrderOpenPrice()-MarketInfo(OrderSymbol(),MODE_ASK))/MarketInfo(OrderSymbol(),MODE_POINT));
            //totalPips += MathRound((OrderOpenPrice()-Ask)/Point);
            totalProfits += OrderProfit();
            break;
         }
      }            
	}
}

void ChartComment()
{

   /*
   string sComment   = "";
   string sp         = "----------------------------------------\n";
   string NL         = "\n";

   sComment = sp;
   sComment = sComment + "Open Positions=" + ScanOpenTrades() + NL;
   sComment = sComment + "Current Profit(pips)= " + totalPips + NL;
   sComment = sComment + "Current Profit(USD) = " + DoubleToStr(totalProfits,2) + NL; 
   sComment = sComment + sp;
   */
  
   //Comment(sComment);
   
   if(ObjectFind("Comment0") != 0)
   {
   ObjectCreate("Comment0", OBJ_LABEL, 0, 0, 0);
   }
   ObjectSetText("Comment0","Open Positions = " + ScanOpenTrades(), 9, "Verdana", CommentClr);
   ObjectSet("Comment0", OBJPROP_XDISTANCE, 25);
   ObjectSet("Comment0", OBJPROP_YDISTANCE, 25);
   
   if(ObjectFind("Comment1") != 0)
   {
   ObjectCreate("Comment1", OBJ_LABEL, 0, 0, 0);
   }
   ObjectSetText("Comment1","Current Profit (pips)= " + totalPips, 9, "Verdana", CommentClr);
   ObjectSet("Comment1", OBJPROP_XDISTANCE, 25);
   ObjectSet("Comment1", OBJPROP_YDISTANCE, 50);
   
   if(ObjectFind("Comment2") != 0)
   {
   ObjectCreate("Comment2", OBJ_LABEL, 0, 0, 0);
   }
   ObjectSetText("Comment2","Current Profit (USD) = " + DoubleToStr(totalProfits,2), 9, "Verdana", CommentClr);
   ObjectSet("Comment2", OBJPROP_XDISTANCE, 25);
   ObjectSet("Comment2", OBJPROP_YDISTANCE, 75);
}	   
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   int j;
   for(j=0;j<3;j++){
      ObjectDelete("Comment" + j);
   }
   ObjectDelete("DayRangeRmUp");
   ObjectDelete("DayRangeRmDn");
//----
   return(0);
  }
  
void TrailOrders(){
   // if we have travelled more than our risk then close half position 
   // and move to breakeven.
   
   // get order number then see if it exists in our file of previously moved orders 
   bool bLockedInProfit = false;
   int iOrderTicket;
   int iShift = 1;
   int iBBStopsUp, iBBStopsDown;
   int iProfitPips;
  
   // calculate trailing stop... 
   double dTrailingMa = iMA(NULL,PERIOD_M1,MA,0,MODE_SMA,PRICE_WEIGHTED,1);
   //double dCurrentPrice = iClose(NULL, 0, 1);
   
  // Comment("BBStops Upper:" + smax + " Lower:" + smin + " ClosePrice: " + dClosePrice + " " + iBBStopsUp + " " + iBBStopsDown);
   
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
        {
            iOrderTicket = OrderTicket();
            switch(OrderType()){
               case OP_BUY:
                
                  iProfitPips += MathRound((MarketInfo(OrderSymbol(),MODE_BID)-OrderOpenPrice())/MarketInfo(OrderSymbol(),MODE_POINT));
                  if(OrderStopLoss() < OrderOpenPrice()){bLockedInProfit = false;} else {bLockedInProfit = true;} 
                  // see if we need to close half and move to be
                  if(bLockedInProfit == false && iProfitPips >= ProfitTarget){
                  
                     // close half lots move sl to be
                     //OrderClose(iOrderTicket, OrderLots()/2, MarketInfo(OrderSymbol(),MODE_BID), iSlippage, Yellow);
                     OrderModify(iOrderTicket, OrderOpenPrice(), OrderOpenPrice() + ProfitTarget*Point, 0, 0, Blue);
                  }
                  // trail bat atr 
                  if(bLockedInProfit == true && OrderStopLoss() <  dTrailingMa ){
                     OrderModify(iOrderTicket, OrderOpenPrice(), dTrailingMa, 0, 0, Red);
                  }
                  break;
               case OP_SELL:
                   iProfitPips = MathRound((OrderOpenPrice()-MarketInfo(OrderSymbol(),MODE_ASK))/MarketInfo(OrderSymbol(),MODE_POINT));
                  if(OrderStopLoss() > OrderOpenPrice()){bLockedInProfit = false;} else {bLockedInProfit = true;} 
                  // see if we need to close half and move to be
                  if(bLockedInProfit == false && iProfitPips >= ProfitTarget){
                     // close half move sl to be
                      //OrderClose(iOrderTicket, OrderLots()/2, MarketInfo(OrderSymbol(),MODE_ASK), iSlippage, Yellow);
                      OrderModify(iOrderTicket, OrderOpenPrice(), OrderOpenPrice() - ProfitTarget * Point, 0, 0, Blue);
                  }
                  if(bLockedInProfit == true && OrderStopLoss() > dTrailingMa){
                     OrderModify(iOrderTicket, OrderOpenPrice(), dTrailingMa, 0, 0, Red);
                  }
                  break;
               default:
                  break;
               }//end switch 
         }// end if 1
        
    }// end for 
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   if(ScanOpenTrades()==0) CloseSignal=false;
   
   TotalProfit();
   ChartComment();
    
   if (!StopManageAcc)
   {
      if(ScanOpenTrades() > 0 && !CloseSignal && (ProfitTarget>0 || MaxLoss>0))
      {
         if(UsePips)
         {
         if(totalPips>=ProfitTarget){
               TrailOrders();
            }else if(totalPips <= -MaxLoss) {
               CloseSignal=true;}    
         //Print("pips: totalPips =",totalPips," signal=",CloseSignal); 
         }       
      }   
   }
   else 
   { if (ScanOpenTrades() > 0) CloseSignal=true;}    
   
   //Print("Signal=",CloseSignal);
   if( CloseSignal ) OpenOrdClose();
   
   // Draw Range
   if(DrawDayRange)DrawRange();
         
 return(0);
}//int start
//+------------------------------------------------------------------+

void DrawRange(){

   int R1=0,R5=0,R10=0,R20=0,RAvg=0;
   int i=0, RoomUp, RoomDown;
   double dRoomUp, dRoomDown;

   R1 =  (iHigh(Symbol(),PERIOD_D1,1)-iLow(Symbol(),PERIOD_D1,1))/Point;
   for(i=1;i<=5;i++)
      R5    =    R5  +  (iHigh(Symbol(),PERIOD_D1,i)-iLow(Symbol(),PERIOD_D1,i))/Point;
   for(i=1;i<=10;i++)
      R10   =    R10 +  (iHigh(Symbol(),PERIOD_D1,i)-iLow(Symbol(),PERIOD_D1,i))/Point;
   for(i=1;i<=20;i++)
      R20   =    R20 +  (iHigh(Symbol(),PERIOD_D1,i)-iLow(Symbol(),PERIOD_D1,i))/Point;

   R5 = R5/5;
   R10 = R10/10;
   R20 = R20/20;
   RAvg  =  (R1+R5+R10+R20)/4; //RAvg  =  (R5+R10+R20)/3;new setting 
   
   RoomUp   =  RAvg - (Bid - (iLow(NULL,PERIOD_D1,0)))/Point;
   RoomDown =  RAvg - ((iHigh(NULL,PERIOD_D1,0)) - Bid)/Point;
   
   dRoomUp = Bid+RoomUp*Point;
   dRoomDown = Ask-RoomDown*Point;
      
   if(ObjectFind("DayRangeRmUp") != 0){
      ObjectCreate("DayRangeRmUp",OBJ_HLINE,0,Time[0],dRoomUp);
      ObjectSet("DayRangeRmUp", OBJPROP_COLOR, DodgerBlue);
      ObjectSet("DayRangeRmUp", OBJPROP_WIDTH, 1);
      ObjectSet("DayRangeRmUp", OBJPROP_STYLE, STYLE_DOT);
   }else{
      ObjectMove("DayRangeRmUp",0,Time[0],dRoomUp);
   }
   
   if(ObjectFind("DayRangeRmDn") != 0){
      ObjectCreate("DayRangeRmDn",OBJ_HLINE,0,Time[0],dRoomDown);
      ObjectSet("DayRangeRmDn", OBJPROP_COLOR, Red);
      ObjectSet("DayRangeRmDn", OBJPROP_WIDTH, 1);
      ObjectSet("DayRangeRmDn", OBJPROP_STYLE, STYLE_DOT);
   }else{
      ObjectMove("DayRangeRmDn",0,Time[0],dRoomDown);
   }
   
   /*
   if(ObjectFind("DayRangeRmDnLabel") != 0){
      ObjectCreate("DayRangeRmDnLabel", OBJ_TEXT, 0, Time[0], dRoomDown-(5*Point));
   }else{
      ObjectMove("DayRangeRmDnLabel", 0, Time[0], dRoomDown-(5*Point));  
   }
   ObjectSetText("DayRangeRmDnLabel", "Range Down", 10, "Arial", White);
   
   
   if(ObjectFind("DayRangeRmUpLabel") != 0){
      ObjectCreate("DayRangeRmUpLabel", OBJ_TEXT, 0, Time[0], dRoomUp+(10*Point)); 
   }else{
      ObjectMove("DayRangeRmUpLabel", 0, Time[0], dRoomUp+(10*Point));
   }
   ObjectSetText("DayRangeRmUpLabel", "Range Up", 10, "Arial", White);
   */
}





